require "Love3D"

function love.load()
	vp = {}
	vp.x = love.graphics.getWidth() * 0.5
	vp.y = love.graphics.getHeight() * 0.4
	
	fl = 500
	love3D.load(fl, vp.x, vp.y)
	love3D.light.load()
	brt = 1
	lgt = {}
	lgt.x = 0
	lgt.y = 0
	lgt.z = -200
	
	cam = {}
	cam.x = 0
	cam.y = 100
	cam.z = 0
	
	ring = love.graphics.newImage("ring.gif")
	
	theta = 0
end

function love.keypressed(key)
	if key == "escape" then love.event.push("quit") end
end

function love.update(dt)
	local step = 1000
	
	--cam.z = cam.z + 1000*dt
	
	if love.keyboard.isDown("left") then
		cam.x = cam.x - step*dt
	end
	
	if love.keyboard.isDown("right") then
		cam.x = cam.x + step*dt
	end
	
	if love.keyboard.isDown("up") then
		cam.y = cam.y - step*dt
	end
	
	if love.keyboard.isDown("down") then
		cam.y = cam.y + step*dt
	end
	
	if love.keyboard.isDown("w") then
		cam.z = cam.z + step*dt
	end
	
	if love.keyboard.isDown("s") then
		cam.z = cam.z - step*dt
	end
	
	if love.keyboard.isDown("q") then
		theta = theta + dt
	end
	
	if love.keyboard.isDown("e") then
		theta = theta - dt
	end
end

function love.draw()
	local rh = 40
	local imin, imax = -9, 10
	local jmin, jmax = 1, 20
	for i=imin,imax do
		for j=jmin,jmax do
			---[[
			love.graphics.setColor(255,255 * ((i+j)%2),0,255)
			love3D.graphics.quad("fill",
			200 + 200*i - cam.x, 300 - cam.y, 200 + 200*j - cam.z,
			0 + 200*i - cam.x, 300 - cam.y, 200 + 200*j - cam.z,
			0 + 200*i - cam.x, 300 - cam.y, 0 + 200*j - cam.z,
			200 + 200*i - cam.x, 300 - cam.y, 0 + 200*j - cam.z)
			local d = math.sqrt((1-2)^2 + (3-4)^2 + (5-6)^2)
			--]]
		end
	end
	for j=jmax,jmin,-1 do
		for i=imax,imin,-1 do
			love.graphics.setColor(255,255,255,255)
			--if (i+j) % 3 == 1 then
				love3D.graphics.draw2D(ring, 0 + 200*i - cam.x, 300 - rh - cam.y, 0 + 200*j - cam.z, 0, 4, 4, 8, 8, true)
			--end
			
		end
	end
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.setCaption((imax-imin+1)*(jmax-jmin+1) .. " quads: " .. love.timer.getFPS() .. " FPS")
end